import java.security.Provider;
import java.security.Security;
import javax.crypto.Cipher;
import java.security.NoSuchAlgorithmException;
import javax.crypto.NoSuchPaddingException;
import java.util.List;
import java.util.Arrays;

public class CheckFIPS {
  public static Boolean check_only_provider_bcfips() {
    Provider[] providers = Security.getProviders();
    List<String> allowed_providers = Arrays.asList("BCFIPS", "BCJSSE");

    System.out.printf("Info: Providers found:");
    for (int i = 0; i < providers.length; i++) {
      System.out.printf(" " + providers[i].getName());
    }
    System.out.println();

    for(int i = 0 ; i < providers.length; i++) {
        if(! allowed_providers.contains(providers[i].getName())) {
            System.out.printf("Error: expected exactly %d providers: %s\n", allowed_providers.size(), Arrays.toString(allowed_providers.toArray()));
            return false;
	}
    }

  System.out.println("Info: check 'Providers' successful");
  return true;
  }

  public static Boolean check_aes_works() {

    try {
      Cipher myCipher = Cipher.getInstance("AES");
      System.out.println("Info: check 'AES' successful");

    }
    catch (NoSuchAlgorithmException e) {
      System.out.println("Error: AES not working");
      return false;
      //throw new RuntimeException(e);
    }
    catch (NoSuchPaddingException e) {
      throw new RuntimeException(e);
    }

    return true;
  }

  public static Boolean check_des_not_allowed() {

    try {
      Cipher myCipher = Cipher.getInstance("DES");
      System.out.println("Error: bad algorithm allowed - DES");

    }
    catch (NoSuchAlgorithmException e) {
      System.out.println("Info: check 'no DES' successful");
      return true;
      //throw new RuntimeException(e);
    }
    catch (NoSuchPaddingException e) {
      throw new RuntimeException(e);
    }

    return false;
  }

  public static void main(String args[]) {
    final int ERROR_NO_ALLOWED_ALGO = 1;
    final int ERROR_FIPS_PROVIDERS = 2;
    final int ERROR_BAD_ALGORITHM = 3;

    if (!check_aes_works()) {
      System.exit(ERROR_NO_ALLOWED_ALGO);
    }

    if (!check_des_not_allowed()) {
      System.exit(ERROR_BAD_ALGORITHM);
    }

    if (!check_only_provider_bcfips()) {
      System.exit(ERROR_FIPS_PROVIDERS);
    }    

  }
}
